function exportTemplateFile () {
    let imageData = "";
    if ( ! document.getElementById("image_data").src.includes("none.png") ) {
        imageData = document.getElementById("image_data").src;
    }

    let midiOutputPreference = null;
    if (document.getElementById("midi_output_preference").value != "null") {
        midiOutputPreference = document.getElementById("midi_output_preference").value;
    }
    const templateObject = {
        "color": document.getElementById("main_color").value,
        "hide_template_name": document.getElementById("hide_template_name").checked,
        "image_data": imageData,
        "keyboard_assignments": JSON.parse(document.getElementById("keyboard_assignments").value),
        "midi_output_preference": midiOutputPreference,
        "pages": JSON.parse(document.getElementById("pages").value),
        "pedal_assignments": JSON.parse(document.getElementById("pedal_assignments").value),
        "template_name": document.getElementById("template_name").value,
        "touchstrip_assignments": JSON.parse(document.getElementById("touchstrip_assignments").value),
        "wheel_assignments": JSON.parse(document.getElementById("wheel_assignments").value)
    };

    getPagesDomValues(templateObject.pages);


    // templateObject.pages[0].buttons[0].label = document.getElementById("buttons_1_1").value;
    // templateObject.pages[0].knobs[0].label = document.getElementById("knobs_1_1").value;


    const generatedCode = document.createElement("textarea");
    generatedCode.textContent = JSON.stringify(templateObject, null, 4);

    const templateBlob = new Blob([generatedCode.textContent], {type: "text/plain"});
    let fileName = document.getElementById("template_name").value + ".kmt";
    const downloadFile = new File([templateBlob], "fileName");
    const templateUrl = URL.createObjectURL(downloadFile);

    var downloadLink = document.getElementById("template_link");
    downloadLink.href = templateUrl;
    downloadLink.setAttribute("download", fileName);
    downloadLink.textContent = fileName;
    downloadLink.click();

}

function getPagesDomValues(templateSection) {
    for (let pageIndex = 0; pageIndex < templateSection.length; pageIndex++) {
        for (let buttonIndex = 0; buttonIndex < templateSection[pageIndex].buttons.length; buttonIndex++) {

            if (templateSection[pageIndex].buttons[buttonIndex] != null) {

                templateSection[pageIndex].buttons[buttonIndex].color = document.getElementById(`button_color_${pageIndex}_${buttonIndex}`).value;
                templateSection[pageIndex].buttons[buttonIndex].label = document.getElementById(`button_label_${pageIndex}_${buttonIndex}`).value;
                if ( 
                    ( document.getElementById(`button_label_${pageIndex}_${buttonIndex}`).value.substring(0, 3) == "CC " )
                    || ( document.getElementById(`button_label_${pageIndex}_${buttonIndex}`).value == "PC" )
                    || ( document.getElementById(`button_label_${pageIndex}_${buttonIndex}`).value == "NO") 
                ) {
                    templateSection[pageIndex].buttons[buttonIndex].custom_label = false;
                }
                else {
                    templateSection[pageIndex].buttons[buttonIndex].custom_label = true;
                }

            }


        }
        for (let knobIndex = 0; knobIndex < templateSection[pageIndex].knobs.length; knobIndex++) {

            if (templateSection[pageIndex].knobs[knobIndex] != null) {

                templateSection[pageIndex].knobs[knobIndex].label = document.getElementById(`knob_${pageIndex}_${knobIndex}`).value;
                if ( 
                    ( document.getElementById(`knob_${pageIndex}_${knobIndex}`).value.substring(0, 3) == "CC " )
                    || ( document.getElementById(`knob_${pageIndex}_${knobIndex}`).value == "PC" )
                ) {
                    templateSection[pageIndex].knobs[knobIndex].custom_label = false;
                }
                else {
                    templateSection[pageIndex].knobs[knobIndex].custom_label = true;
                }
                templateSection[pageIndex].knobs[knobIndex].display_mode = document.getElementById(`knob_display_mode_${pageIndex}_${knobIndex}`).value;

            }
        }
    }
}
