function populatePageDom(pageIndex, page) {

    const newContainer = document.createElement("details");
    newContainer.id = `page_${pageIndex}`;
    newContainer.name = `page_${pageIndex}_details`;
    newContainer.open = true;
    newContainer.classList.add("page_section");

    const newContainerLabel = document.createElement("summary");
    newContainerLabel.textContent = `Page ${pageIndex + 1}`;
    newContainer.appendChild(newContainerLabel);


    const newGrid = document.createElement("div");
    newGrid.id = `grid_${pageIndex}`;
    newGrid.classList.add("page_grid");
    newContainer.appendChild(newGrid);
    

    // build the grid
    const pageRowLabels = ["Button LED Color", "Button Label", "Button/Knob", "Knob Label", "Display Mode"];

    for (let rowIndex = 0; rowIndex < 5; rowIndex++) {

        // row labels
        const newLabel = document.createElement("div");
        newLabel.classList.add("page_section_row_label");
        newLabel.textContent = inputItemConfig.pageRowLabels[rowIndex];
        newGrid.appendChild(newLabel);

        // iterate through the columns for 8 buttons/knobs
        for (let colIndex = 0; colIndex < 8; colIndex++) {
            // console.log("pageIndex: ", pageIndex,  "|| rowIndex: ", rowIndex, "|| colIndex: ", colIndex, );

            // div for the grid cell
            const newContainerCell = document.createElement("div");
            newContainerCell.classList.add("page_section_cell");
            newGrid.appendChild(newContainerCell);

            if (rowIndex == 0) {

                // Button LED color
                if (page.buttons[colIndex] != null) {
                    const newColorMenu = domAddSelect(`button_color_${pageIndex}_${colIndex}`, inputItemConfig.button_color, page.buttons[colIndex].color);
                    newColorMenu.classList.add("page_section_cell");
                    newColorMenu.title = `Button LED Color for Page ${pageIndex + 1} Button ${colIndex + 1}`;
                    newContainerCell.appendChild(newColorMenu);    
                }
            }
            else if (rowIndex == 1) {
                // Button label
                if (page.buttons[colIndex] != null) {
                    const newButtonLabel = domAddInputText(`button_label_${pageIndex}_${colIndex}`, inputItemConfig.button_label, page.buttons[colIndex].label);
                    newButtonLabel.classList.add("page_section_cell");
                    newButtonLabel.title = `Button Label for Page ${pageIndex + 1} Button ${colIndex + 1}`;
                    newContainerCell.appendChild(newButtonLabel);
                }
            }
            else if (rowIndex == 2) {
                // column label
                const newColumnLabel = document.createElement("div");
                newColumnLabel.classList.add("page_section_column_label");
                newColumnLabel.textContent = `${colIndex + 1}`;
                newContainerCell.appendChild(newColumnLabel);
            }
            else if (rowIndex == 3) {
                // Knob label
                if (page.knobs[colIndex] != null) {
                    const newKnobLabel = domAddInputText(`knob_${pageIndex}_${colIndex}`, inputItemConfig.knob_label, page.knobs[colIndex].label);
                    newKnobLabel.classList.add("page_section_cell");
                    newKnobLabel.title = `Knob Label for Page ${pageIndex + 1} Knob ${colIndex + 1}`;
                    newContainerCell.appendChild(newKnobLabel);
                }
            }
            else if (rowIndex == 4) {
                // Knob display mode
                if (page.knobs[colIndex] != null) {
                    const newDisplayModeMenu = domAddSelect(`knob_display_mode_${pageIndex}_${colIndex}`, inputItemConfig.knob_display_mode, page.knobs[colIndex].display_mode);
                    newDisplayModeMenu.classList.add("page_section_cell");
                    newDisplayModeMenu.title = `Knob Display Mode for Page ${pageIndex + 1} Knob ${colIndex + 1}`;
                    newContainerCell.appendChild(newDisplayModeMenu);
                }
            }
        }
    }

    return newContainer;
}
