
function populateDom(kmtTemplate) {

    populateGeneralSettingsDom(kmtTemplate);

    populateCopyPartsDom();

    populatePagesDom(kmtTemplate.pages);

    // populatePedalAssignmentsDom(kmtTemplate);

    // make the "Save" button visible.
    document.getElementById("save_template_file").disabled = false;
    document.getElementById("save_template_file").style.opacity = "1";
    document.getElementById("save_template_file").title = "Press this button to save the changes to this template file...";
    
    populateDebugSectionDom(kmtTemplate);

}

function populateCopyPartsDom() {

    const currentDomSection = document.getElementById("copy_parts_section");
    currentDomSection.innerHTML = "<p><b>CAUTION:</b> Do this <b>before</b> editing detail items in the sections below. Otherwise you may inadvertently overwrite them.</p><br>";
    let htmlSummary = document.createElement("summary");
    htmlSummary.textContent = uiConfig.level_1_sections.copy_parts_section.summary;
    currentDomSection.appendChild(htmlSummary);

    currentDomSection.appendChild(domAddMultiCheckbox("parts_selection", uiConfig.parts_selection));

    const templateFile2 = domAddInputFile("import_template_2", uiConfig.template_file_2, importTemplateFile, "import_template_2");
    currentDomSection.appendChild(templateFile2);

}

function populateGeneralSettingsDom(kmtTemplate) {

    let currentDomSection = document.getElementById("general_settings_section");
    currentDomSection.innerHTML = "";
    let htmlSummary = document.createElement("summary");
    htmlSummary.textContent = uiConfig.level_1_sections.general_settings_section.summary;
    currentDomSection.appendChild(htmlSummary);

    currentDomSection.appendChild(domAddInputText("template_name", inputItemConfig.template_name, kmtTemplate.template_name));
    // document.getElementById("template_name").value = kmtTemplate.template_name;

    currentDomSection.appendChild(domAddInputCheckbox("hide_template_name", inputItemConfig.hide_template_name, ""));
    document.getElementById("hide_template_name").checked = kmtTemplate.hide_template_name;


    currentDomSection.appendChild(domAddImage("image_data", inputItemConfig.image_data, "img/none.png", sizeImage));
    if (kmtTemplate.image_data != "") {
        document.getElementById("image_data").src = kmtTemplate.image_data;
    }
    else {
        removeImage(document.getElementById("image_data"));
    }

    currentDomSection.appendChild(domAddButton("remove_image", uiConfig.remove_image, removeImage, document.getElementById("image_data")));
    currentDomSection.appendChild(domAddInputFile("import_image", uiConfig.image_file, importImageFile));

    currentDomSection.appendChild(document.createElement("hr"));
    // currentDomSection.appendChild(document.createElement("br"));

    currentDomSection.appendChild(domAddSelect("main_color", inputItemConfig.color, kmtTemplate.color));

    if (kmtTemplate.hasOwnProperty("midi_output_preference")) {
        currentDomSection.appendChild(domAddSelect("midi_output_preference", inputItemConfig.midi_output_preference, kmtTemplate.midi_output_preference));
        // document.getElementById("midi_output_preference").value = kmtTemplate.midi_output_preference; 
        // const optionList = document.getElementById("midi_output_preference").children ;
        // for (let thisOption of optionList) {
        //     if (thisOption.value == kmtTemplate.midi_output_preference) {
        //         thisOption.selected = true;
        //     }
        // }
    }
    else {
        currentDomSection.appendChild(domAddSelect("midi_output_preference", inputItemConfig.midi_output_preference, null));
    }

}

function populatePedalAssignmentsDom(kmtTemplate) {

    currentDomSection = document.getElementById("pedal_settings_section");
    currentDomSection.innerHTML = "";
    htmlSummary = document.createElement("summary");
    htmlSummary.textContent = "Pedal Settings";
    currentDomSection.appendChild(htmlSummary);

    for (const [pedalName, pedalLabel] of Object.entries(pedalConfig)) {
        const pedalContainer = populatePedalDom(pedalName, pedalLabel, kmtTemplate.pedal_assignments[pedalName]);
        currentDomSection.appendChild(pedalContainer);
    }

}

function populatePagesDom(templateSection) {
    currentDomSection = document.getElementById("pages_section");
    currentDomSection.innerHTML = "";
    htmlSummary = document.createElement("summary");
    htmlSummary.textContent = "Button and Knob Pages";
    currentDomSection.appendChild(htmlSummary);

    for (let pageIndex = 0; pageIndex < templateSection.length; pageIndex++) {
        const pageContainer = populatePageDom(pageIndex, templateSection[pageIndex]);
        currentDomSection.appendChild(pageContainer);
    }
}

function populateDebugSectionDom(kmtTemplate) {

    currentDomSection = document.getElementById("code_section");
    currentDomSection.innerHTML = "<p><b>CAUTION:</b> This section only shows what has been imported. It does <b>not</b> reflect your changes to individual fields.</p>";
    htmlSummary = document.createElement("summary");
    htmlSummary.textContent = "Debugging Section";

    currentDomSection.appendChild(htmlSummary);

    const jsonRootCode = {};
    for (const [key, value] of Object.entries(kmtTemplate)) {
        if ( (typeof value === 'object') && value !== null) {
            currentDomSection.appendChild(domAddTextArea(`${key}`, codeDisplayConfig[key], JSON.stringify(kmtTemplate[key], null, 4)));
        }
        else {
            jsonRootCode[key] = value;
        }
    }
    currentDomSection.appendChild(domAddTextArea("json_root_code", codeDisplayConfig.json_root, JSON.stringify(jsonRootCode, null, 4)));

}

function importSections (sourceTemplate) {
    
    for (const [key, value] of Object.entries(uiConfig.parts_selection.options)) {
        if (document.getElementById(`parts_selection_${value}`).checked) {
            
            document.getElementById(value).value = JSON.stringify(sourceTemplate[value], null, 4);
            if (value == "pages") {
            populatePagesDom(sourceTemplate.pages); 
            }
        }
    }
}