function importImageFile() {
    // from user's machine

    const imgData = document.getElementById("image_data");
    const file = document.getElementById("import_image").files[0];

    const reader = new FileReader();

    reader.addEventListener(
        "load",
        () => {
          // convert image file to base64 string
          imgData.src = reader.result;
        },
        false,
    );

      if (file) {
        reader.readAsDataURL(file);
      }  

}

function removeImage(imgObject) {

  // if there's no image for the template, we'll display a placeholder empty image of the correct size in the web page instead
  
    imgObject.src = "img/none.png";
  }
      
function sizeImage(imgData) {
    const imageWidth = imgData.naturalWidth;
    const imageHeight = imgData.naturalHeight;    

    if (imgData.src.includes("none.png") ) {
      document.getElementById("image_data_figcaption").textContent = "no image selected";
      document.getElementById("image_data_figcaption").style.removeProperty("color");
      document.getElementById("image_data_figcaption").style.backgroundColor = "transparent";  
      document.getElementById("remove_image_wrapper").style.visibility = "collapse";
      imgData.setAttribute("alt", document.getElementById("image_data_figcaption").textContent);
      document.getElementById("hide_template_name").checked = false;
      document.getElementById("hide_template_name_wrapper").style.display = "none";

    }
    else {
        if ( (imageWidth == 1280) && (imageHeight == 212) ) {
            document.getElementById("image_data_figcaption").textContent = "Image Size is OK: " + imageWidth + " x " + imageHeight;
            document.getElementById("image_data_figcaption").style.removeProperty("color");
            document.getElementById("image_data_figcaption").style.backgroundColor = "transparent";  
        }
        else {
          document.getElementById("image_data_figcaption").textContent = "ERROR: Image Size has to be 1280x212" +  ` (while the shown image is ${imageWidth} x ${imageHeight})`;
          document.getElementById("image_data_figcaption").style.color = "black";
          document.getElementById("image_data_figcaption").style.backgroundColor = "red";
        }
        document.getElementById("remove_image").style.visibility = "visible";
        document.getElementById("hide_template_name_wrapper").style.display = null;
      }
    imgData.setAttribute("alt", document.getElementById("image_data_figcaption").textContent);
    imgData.setAttribute("title", document.getElementById("image_data_figcaption").textContent);
}