
const kmtDom =
{
    "color": {
        "type": "select",
        "label": "Default LED Color",
        "label_position": "left",
        "tip" : "LED color for wheels, touchstrip, 4-D encoder, and default light guide color.",
        "options": {
            "Hardware Default": "",
            "White": "White",
            "Red": "Red", 
            "Orange": "Orange", 
            "Light Orange": "Light Orange", 
            "Warm Yellow": "Warm Yellow", 
            "Yellow": "Yellow", 
            "Lime": "Lime", 
            "Green": "Green", 
            "Mint": "Mint", 
            "Cyan": "Cyan", 
            "Turquoise": "Turquoise", 
            "Blue": "Blue", 
            "Plum": "Plum", 
            "Violet": "Violet", 
            "Purple": "Purple", 
            "Magenta": "Magenta", 
            "Fuchsia": "Fuchsia"
        }
    },
    "hide_template_name": {
        "type": "boolean",
        "label": "Hide Template Name",
        "label_position": "right",
        "tip": "This only matters when there actually is an image for this template"
    },
    "image_data": {
        "type": "image",
        "label": "Import a template image",
        "label_position": "top_left",
        "fig_caption": "Template Image",
        "onchange": "importImageFile()",
        "accept": "image/webp, image/png, image/jpeg",
        "width": 1280,
        "height": 212,
    },
    "keyboard_assignments": {
        "type": "array_of_objects",
        "label": "Keyboard Assignments",
        "label_position": "top_left",
        "tip": "Up to 16 keyzones",
        "min_length": 1,
        "max_length": 16,
        "object": {
            "color": {
                "type": "select",
                "label": "Default LED Color",
                "label_position": "left",
                "tip" : "LED color for wheels, touchstrip, 4-D encoder, and default light guide color.",
                "options": {
                    "Hardware Default": "",
                    "White": "White",
                    "Red": "Red", 
                    "Orange": "Orange", 
                    "Light Orange": "Light Orange", 
                    "Warm Yellow": "Warm Yellow", 
                    "Yellow": "Yellow", 
                    "Lime": "Lime", 
                    "Green": "Green", 
                    "Mint": "Mint", 
                    "Cyan": "Cyan", 
                    "Turquoise": "Turquoise", 
                    "Blue": "Blue", 
                    "Plum": "Plum", 
                    "Violet": "Violet", 
                    "Purple": "Purple", 
                    "Magenta": "Magenta", 
                    "Fuchsia": "Fuchsia"
                }        
            },
            "disable": {
                "type": "boolean",
                "label": "Disable keyzone",
                "label_position": "right",
                "tip": "Disable this keyzone"
            },
            "midi_channel": {
                "type": "number",
                "label": "MIDI Channel",
                "label_position": "left",
                "tip": "Between 1 and 16",
                "ui-offset": 1,
                "min": 0,
                "max": 15,
                "step": 1
            },
            "priority": {
                "type": "select",
                "label": "Priority",
                "label_position": "left",
                "tip": "plugin or keyzone",
                "options": {
                    "Plugin": "plugin",
                    "Keyzone": "keyzone"
                }
            },
            "semitones_transpose": {
                "type": "number",
                "label": "Semitones Transpose",
                "label_position": "left",
                "tip": "Between -127 and 127",
                "min": -127,
                "max": 127,
                "step": 1
            },
            "upper_key": {
                "type": "number",
                "label": "Upper Key",
                "label_position": "left",
                "tip": "Between 0 and 127",
                "min": 0,
                "max": 127,
                "step": 1
            },
            "velocity_curve": {
                "type": "select",
                "label": "Velocity Curve",
                "label_position": "left",
                "tip": "Velocity curve for this keyzone",
                "options": {
                    "Default": null,
                    "Soft 1": "soft1",
                    "Soft 2": "soft2",
                    "Soft 3": "soft3",
                    "Linear": "linear",
                    "Hard 1": "hard1",
                    "Hard 2": "hard2",
                    "Hard 3": "hard3"
                }
            }
        }
    },
    "midi_output_preference": {
        "type": "select",
        "label": "MIDI Output Port",
        "label_position": "left",
        "tip": "Transmit MIDI to ...",
        "options": {
            "Use Hardware Global Setting": null,
            "USB port only": "usb_priority",
            "MIDI port only": "din_priority",
            "Dual: MIDI & USB": "dual" 
       }
    },
    "pages": {
        "type": "array_of_objects",
        "label": "Button and Knob Pages",
        "label_position": "top_left",
        "tip": "Up to 16 pages",
        "min_length": 1,
        "max_length": 16,
        "object": {
            "buttons": {
                "type": "array_of_objects",
                "label": "Buttons",
                "label_position": "none",
                "tip": "The buttons above the knobs",
                "min_length": 8,
                "max_length" : 8,
                "object": {
                    "color": {
                        "type": "select",
                        "label": "Button LED Color",
                        "label_position": "left",
                        "tip" : "LED color for this button",
                        "options": {
                            "Hardware Default": "",
                            "White": "White",
                            "Red": "Red", 
                            "Orange": "Orange", 
                            "Light Orange": "Light Orange", 
                            "Warm Yellow": "Warm Yellow", 
                            "Yellow": "Yellow", 
                            "Lime": "Lime", 
                            "Green": "Green", 
                            "Mint": "Mint", 
                            "Cyan": "Cyan", 
                            "Turquoise": "Turquoise", 
                            "Blue": "Blue", 
                            "Plum": "Plum", 
                            "Violet": "Violet", 
                            "Purple": "Purple", 
                            "Magenta": "Magenta", 
                            "Fuchsia": "Fuchsia"
                        }
                    },
                    "custom_label": {
                        "type": "boolean",
                        "label": "Custom Label",
                        "label_position": "right",
                        "tip": "not sure, if this actually does anything"
                    },
                    "label": {
                        "type": "text",
                        "label": "Label",
                        "label_position": "left",
                        "tip": "Up to 16 characters",
                        "min_length": 1,
                        "max_length": 16
                    },
                    "mapping": {
                        "type": "object",
                        "label": "Mapping",
                        "label_position": "none",
                        "tip": "MIDI mapping for this button",
                        "object": {
                            "assignment": {
                                "type": "select_of_objects",
                                "label": "Assignment",
                                "label_position": "left",
                                "options": {
                                    "Cntrl Chg": "cc",
                                    "Prgrm Chg": "program_change",
                                    "Note On": "note_on"
                                },
                                "object": {
                                    "cc": {
                                        "type": "object",
                                        "label": "CC",
                                        "label_position": "none",
                                        "tip": "MIDI CC",
                                        "object": {
                                            "midi_cc_number": {
                                                "type": "number",
                                                "label": "CC Number",
                                                "label_position": "left",
                                                "tip": "Between 0 and 127",
                                                "min": 0,
                                                "max": 127,
                                                "step": 1
                                            },
                                            "midi_channel": {
                                                "type": "number",
                                                "label": "MIDI Channel",
                                                "label_position": "left",
                                                "tip": "Between 1 and 16",
                                                "ui-offset": 1,
                                                "min": 0,
                                                "max": 15,
                                                "step": 1
                                            },
                                                                        }
                                    },                                                
                                    "program_change": {
                                        "type": "object",
                                        "label": "Program Change",
                                        "label_position": "none",
                                        "tip": "MIDI Program Change",
                                        "object": {
                                            "midi_channel": {
                                                "type": "number",
                                                "label": "MIDI Channel",
                                                "label_position": "left",
                                                "tip": "Between 1 and 16",
                                                "ui-offset": 1,
                                                "min": 0,
                                                "max": 15,
                                                "step": 1
                                            }
                                        }
                                    
                                    }
                                }
                            }
                        }
                    }
                }
            }
        }
    },


    "template_name": {
        "type": "text",
        "label": "Template Name",
        "label_position": "left",
        "title" : "Max 32 characters long",
        "min-lenght": 1,
        "max-lenght": 32
    },
};